> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tracecat.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Managed Tunnel

> Create a tunnel whose Pangolin site, machine client, and resources Tracecat provisions.

The site credentials and install command are returned only in this response.



## OpenAPI

````yaml https://platform.tracecat.com/api/openapi.json post /workspaces/{workspace_id}/tunnels/managed
openapi: 3.1.0
info:
  title: Tracecat API
  summary: Tracecat API
  description: The open source AI automation platform for security teams and agents.
  termsOfService: >-
    https://docs.google.com/document/d/e/2PACX-1vQvDe3SoVAPoQc51MgfGCP71IqFYX_rMVEde8zC4qmBCec5f8PLKQRdxa6tsUABT8gWAR9J-EVs2CrQ/pub
  contact:
    name: Tracecat Founders
    email: founders@tracecat.com
  license:
    name: AGPL-3.0
    url: https://www.gnu.org/licenses/agpl-3.0.html
  version: '1'
servers:
  - url: /api
security: []
tags:
  - name: public
    description: Public facing endpoints
  - name: workflows
    description: Workflow management
  - name: actions
    description: Action management
  - name: triggers
    description: Workflow triggers
  - name: secrets
    description: Secret management
  - name: variables
    description: Workspace variable management
paths:
  /workspaces/{workspace_id}/tunnels/managed:
    post:
      tags:
        - tunnels
      summary: Create Managed Tunnel
      description: >-
        Create a tunnel whose Pangolin site, machine client, and resources
        Tracecat provisions.


        The site credentials and install command are returned only in this
        response.
      operationId: tunnels-create_managed_tunnel
      parameters:
        - name: workspace_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            title: Workspace Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ManagedTunnelCreate'
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ManagedTunnelCreated'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyCookie: []
        - ServiceAccountApiKeyBearer: []
components:
  schemas:
    ManagedTunnelCreate:
      properties:
        name:
          type: string
          maxLength: 63
          minLength: 1
          pattern: ^[a-z0-9]([a-z0-9_-]*[a-z0-9])?$
          title: Name
        description:
          anyOf:
            - type: string
              maxLength: 1000
            - type: 'null'
          title: Description
        allowed_targets:
          items:
            $ref: '#/components/schemas/TunnelTarget'
          type: array
          maxItems: 100
          minItems: 1
          title: Allowed Targets
      additionalProperties: false
      type: object
      required:
        - name
        - allowed_targets
      title: ManagedTunnelCreate
      description: >-
        Create a tunnel whose Pangolin site, machine client, and resources
        Tracecat manages.
    ManagedTunnelCreated:
      properties:
        tunnel:
          $ref: '#/components/schemas/TunnelRead'
        site_id:
          type: string
          title: Site Id
        site_secret:
          type: string
          title: Site Secret
        site_endpoint:
          type: string
          title: Site Endpoint
        site_install_command:
          type: string
          title: Site Install Command
      type: object
      required:
        - tunnel
        - site_id
        - site_secret
        - site_endpoint
        - site_install_command
      title: ManagedTunnelCreated
      description: A new managed tunnel. The site credentials are only returned once.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    TunnelTarget:
      properties:
        host:
          type: string
          maxLength: 253
          minLength: 1
          title: Host
          description: >-
            Exact hostname or IP address. Wildcards and CIDR ranges are not
            allowed.
        ports:
          items:
            type: integer
            maximum: 65535
            minimum: 1
          type: array
          maxItems: 64
          minItems: 1
          title: Ports
      additionalProperties: false
      type: object
      required:
        - host
        - ports
      title: TunnelTarget
      description: >-
        A single private host and the TCP ports actions may reach through the
        tunnel.
    TunnelRead:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        workspace_id:
          type: string
          format: uuid
          title: Workspace Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        provider:
          $ref: '#/components/schemas/TunnelProvider'
        endpoint:
          type: string
          title: Endpoint
        client_id:
          type: string
          title: Client Id
        allowed_targets:
          items:
            $ref: '#/components/schemas/TunnelTarget'
          type: array
          title: Allowed Targets
        enabled:
          type: boolean
          title: Enabled
        has_gateway_key:
          type: boolean
          title: Has Gateway Key
        managed:
          type: boolean
          title: Managed
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - id
        - workspace_id
        - name
        - description
        - provider
        - endpoint
        - client_id
        - allowed_targets
        - enabled
        - has_gateway_key
        - managed
        - created_at
        - updated_at
      title: TunnelRead
      description: Tunnel metadata. The client secret is write-only and never returned.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    TunnelProvider:
      type: string
      enum:
        - pangolin
      title: TunnelProvider
  securitySchemes:
    APIKeyCookie:
      type: apiKey
      in: cookie
      name: fastapiusersauth
    ServiceAccountApiKeyBearer:
      type: http
      description: Tracecat service account API key.
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.